]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- pass same flags to %scons as to %configure
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # BuildRequires:        awk
59 # BuildRequires:        rpmbuild(macros) >= 1.315
60 #
61 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
62 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
63 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
64 # %rpmldflags   = %optldflags - %filterout_ld
65 #
66 # Regular expressions are supported, but to avoid some character be treated
67 # as regular expression it must be escaped twice.
68
69 %filter_out                                             \
70         for (i = 1; i in I; i++) {      A=0;    \
71                 for (f in F) {                          \
72                         if (I[i] ~ "^" F[f] "$") A=1;   \
73                 };                                                      \
74                 if (!A) printf(I[i] FS);        \
75         }
76
77 %rpmcflags %(awk 'BEGIN {
78         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
79         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
80         %{filter_out}
81 }')
82
83 %rpmcxxflags %(awk 'BEGIN {
84         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
85         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
86         %{filter_out}
87 }')
88
89 %rpmldflags %(awk 'BEGIN {
90         split("%{?optldflags}",I);
91         split("%{?filterout_ld}",F)
92         %{filter_out}
93 }')
94
95 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
96 # but, don't use it, better use gcc as linker
97 %ld_rpmldflags %(awk 'BEGIN {
98         split("%{rpmldflags}",F);
99         for (f in F) {
100                 s = F[f];
101                 if (s ~ /^-Wl,/) {
102                         s = substr(s,5);
103                         gsub(/,/," ",s);
104                 };
105                 printf(s FS);
106         };
107 }')
108
109 #-----------------------------------------------------------------
110 %configure2_13 { \
111  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
112  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
113  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
114  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
115  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
116  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
117  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
118  %{?__cc:CC="%{__cc}" ; export CC ; } \
119  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
120  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
121         --host=%{_target_platform} \
122         --prefix=%{_prefix} \
123         --exec-prefix=%{_exec_prefix} \
124         --bindir=%{_bindir} \
125         --sbindir=%{_sbindir} \
126         --sysconfdir=%{_sysconfdir} \
127         --datadir=%{_datadir} \
128         --includedir=%{_includedir} \
129         --libdir=%{_libdir} \
130         --libexecdir=%{_libexecdir} \
131         --localstatedir=%{_localstatedir} \
132         --sharedstatedir=%{_sharedstatedir} \
133         --mandir=%{_mandir} \
134         --infodir=%{_infodir} \
135         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
136         %{dependencytracking} \
137 }
138
139 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
140 %__cmake        /usr/bin/cmake
141 %cmake { \
142 CC="%{__cc}" \
143 CXX="%{__cxx}" \
144 CFLAGS="%{rpmcflags}" \
145 CXXFLAGS="%{rpmcxxflags}" \
146 %{__cmake} \
147 }
148
149 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
150 %__scons        /usr/bin/scons
151 %scons { \
152 %{__scons} \
153         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
154         CFLAGS="${CFLAGS:-%rpmcflags}" \
155         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
156         FFLAGS="${FFLAGS:-%rpmcflags}" \
157         CPPFLAGS="${CPPFLAGS:-}" \
158         %{?__cc:CC="%{__cc}"} \
159         %{?__cxx:CXX="%{__cxx}"} \
160         libsuffix=%{_lib} \
161         prefix=%{_prefix} \
162 }
163
164 # waf. see waf.spec
165 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
166 %__waf  /usr/bin/waf
167 %waf { \
168 CC="%{__cc}" \
169 CXX="%{__cxx}" \
170 CPP="%{__cpp}" \
171 CFLAGS="%{rpmcflags}" \
172 CXXFLAGS="%{rpmcxxflags}" \
173 %{__waf} \
174 }
175
176 #----------------------------------------------------------------
177 %global configure_cache 0
178 %configure_cache_file   %{buildroot}.configure.cache
179
180 %configure {./configure \
181         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
182         CFLAGS="${CFLAGS:-%rpmcflags}" \
183         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
184         FFLAGS="${FFLAGS:-%rpmcflags}" \
185         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
186         CPPFLAGS="${CPPFLAGS:-}" \
187         %{?__cc:CC="%{__cc}"} \
188         %{?__cxx:CXX="%{__cxx}"} \
189         --host=%{_target_platform} \
190         --build=%{_target_platform} \
191         --prefix=%{_prefix} \
192         --exec-prefix=%{_exec_prefix} \
193         --bindir=%{_bindir} \
194         --sbindir=%{_sbindir} \
195         --sysconfdir=%{_sysconfdir} \
196         --datadir=%{_datadir} \
197         --includedir=%{_includedir} \
198         --libdir=%{_libdir} \
199         --libexecdir=%{_libexecdir} \
200         --localstatedir=%{_localstatedir} \
201         --sharedstatedir=%{_sharedstatedir} \
202         --mandir=%{_mandir} \
203         --infodir=%{_infodir} \
204         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
205         %{dependencytracking} \
206         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
207 }
208
209 # ------------------------------------------------------------------------
210 # Overloading of some basic macros
211 %prep \
212 %%prep\
213 export LC_ALL=C\
214 export LANG=C\
215 unset LINGUAS ||:\
216 unset LANGUAGE ||:\
217 unset LC_MESSAGES ||:\
218 unset DISPLAY ||:\
219 %{nil}
220
221 %build %%build\
222 export LC_ALL=C\
223 export LANG=C\
224 unset LINGUAS ||:\
225 unset LANGUAGE ||:\
226 unset LC_MESSAGES ||:\
227 unset DISPLAY ||:\
228 %{nil}
229
230 %install \
231 %if 0%{?_enable_debug_packages}\
232 %{?buildsubdir:%{debug_package}}\
233 %endif\
234 %%install\
235 export LC_ALL=C\
236 export LANG=C\
237 unset LINGUAS ||:\
238 unset LANGUAGE ||:\
239 unset LC_MESSAGES ||:\
240 unset DISPLAY ||:\
241 %{nil}
242
243 # Location of autoconf macros
244 %_aclocaldir    %(aclocal --print-ac-dir)
245
246 # Location of omf files
247 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
248
249 # Location of pkgconfig files
250 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
251
252 # Location of desktop files
253 %_desktopdir    /usr/share/applications
254 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
255
256 # Location of pixmaps for applnk/desktop files
257 %_pixmapsdir    /usr/share/pixmaps
258
259 # Location of themable icons for applnk/desktop files
260 %_iconsdir      /usr/share/icons
261
262 # Location of fonts directories
263 %_fontsdir      /usr/share/fonts
264
265 # Location of Gtk and associated libraries documentation
266 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
267
268 # Location of KDE documentation
269 %_kdedocdir     %{_defaultdocdir}/kde/HTML
270
271 # unsermake script
272 %__unsermake /usr/share/unsermake/unsermake
273
274 # Current date
275 %date           %(LC_ALL="C" date +"%a %b %d %Y")
276
277 # tmp directory
278 %tmpdir         %(echo "${TMPDIR:-/tmp}")
279
280 # Example files, programs, scripts...
281 %_examplesdir   /usr/src/examples
282
283 # Alternative kernel type/version
284 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
285
286 # The directory holding Linux kernel sources
287 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
288
289 # If non-empty "debug" macro defined, add "dbg" suffix to release number
290 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
291
292 # Requires name = version-release
293 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
294
295 %releq_kernel()         %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
296 %requires_releq_kernel(s:)      Requires%{-s:(%{-s*})}: %releq_kernel
297
298 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
299 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
300
301 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
302
303 # kernel version-release handling
304 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
305 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
306 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
307 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
308 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
309
310 # sgml macros
311 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
312 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
313 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
314 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
315 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
316 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
317 %docbook_sgmlcat_fix() { for l in \
318 '' \
319 '  -- default decl --' \
320 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
321 '  -- hacks for opensp --' \
322 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
323 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324 '' \
325 ; do echo $l; done >> %1 \
326 }
327
328 # vim - "
329
330 # minimum file size needed for compressed documents.
331 # just smaller files than this get larger when compressed.
332 # some stats:
333 # - 0 byte file compressed was 25 bytes .gz
334 # - 39 byte file was compressed as 57
335 # - with test/test.spec@man 158 byte file was compressed also 158
336 %_min_compress_bytes    159
337
338 #-----------------------------------------------------------------
339 # find and gzip all files in %{_mandir} and %{infodir}
340 #
341 # Requires: xargs, find
342 #
343 #%no_install_post_compress_docs 1
344 %__spec_install_post_compress_docs { \
345 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
346         for i in /usr/share/man /usr/X11R6/man; do \
347                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
348                         echo "Compress man pages: $i"; \
349                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
350                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
351                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
352                 fi; \
353         done; \
354         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
355                 echo "Compress info pages: %{_infodir}"; \
356                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
357                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
358                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359         fi; \
360 }; __spec_install_post_compress_docs } }
361
362 #-----------------------------------------------------------------
363 # Strip executable binaries and shared object files
364 #
365 # Requires: find, awk, strip, cut, xargs
366 #
367 #%no_install_post_strip 1
368 %__spec_install_post_strip {%{!?debug: \
369 %{!?no_install_post_strip:__spec_install_post_strip() { \
370 if [ -d "$RPM_BUILD_ROOT" ]; then \
371         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
372                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
373                 printf "Stripping %d kernel modules..." $(echo "$modulelist" | wc -l); \
374                 echo "$modulelist" | xargs -l512 chmod u+w; \
375                 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
376                 echo "DONE"; \
377         fi; \
378         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
379         # vim - " \
380         if [ -z "$filelist" ]; then \
381                 return; \
382         fi; \
383         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
384         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
385         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
386         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
387         if [ -n "$elfexelist" ]; then \
388                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
389                 chmod u+w $elfexelist; \
390                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
391                 echo "DONE"; \
392         fi; \
393         if [ -n "$elfsharedlist" ]; then \
394                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
395                 chmod u+w $elfsharedlist; \
396                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
397                 echo "DONE"; \
398         fi; \
399         if [ -n "$archiveslist" ]; then \
400                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
401                 chmod u+w $archiveslist; \
402                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
403                 echo "DONE"; \
404         fi; \
405 fi; }; __spec_install_post_strip } } }
406
407 #-----------------------------------------------------------------
408 # remove all RPATH from executable binaries and shared object files
409 #
410 # Requires: find, awk, cut, xargs, chrpath, uname
411 #
412 #%no_install_post_chrpath       1
413 %__spec_install_post_chrpath {%{!?debug: \
414 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
415 if [ -d "$RPM_BUILD_ROOT" ]; then \
416         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
417         if [ -n "$files" ]; then \
418                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
419         fi
420         #"
421         if [ -n "$objs" ]; then \
422                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
423                 echo "$objs" | \
424                 while read file; do \
425                         rpath= ; \
426                         chmod u+w "$file"; \
427                         for dir in `chrpath -l "$file" | \
428                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
429                                         case $dir in \
430                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
431                                                 echo "remove-rpath: $dir in $file"; \
432                                                 ;; \
433                                         * ) \
434                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
435                                                 else rpath="$rpath:$dir" ; fi ; \
436                                                 ;; \
437                                         esac ; \
438                         done ; \
439                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
440                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
441                 done; \
442         fi; \
443 fi; }; __spec_install_post_chrpath } } }
444
445 #-----------------------------------------------------------------
446 # Find and gzip all kernel modules
447 #
448 # Requires: find
449 #
450 #%no_install_post_compress_modules      1
451 %__spec_install_post_compress_modules { \
452 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
453         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
454                 echo "Compress kernel modules"; \
455                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
456                 echo "$q" | xargs -r %{__gzip} -9nf; \
457                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
458                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
459                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
460         fi; \
461 }; __spec_install_post_compress_modules } }
462
463 # Remove common Perl files we don't package
464 %__spec_install_post_perl_clean {\
465 %{!?no_install_post_perl_clean: \
466 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
467 } }
468
469 #-----------------------------------------------------------------
470 # Update GConf2 schemas
471 #
472 # Requires: GConf2
473 #
474 %gconf_schema_install() \
475         umask 022; \
476         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
477         %{nil}
478
479 %gconf_schema_uninstall() \
480 if [ $1 = 0 ]; then \
481         umask 022; \
482         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
483 fi \
484 %{nil}
485
486 #-----------------------------------------------------------------
487 # Update desktop MIME database
488 # requires: desktop-file-utils
489 #
490 %update_desktop_database_post() {{ \
491         umask 022; \
492         /usr/bin/update-desktop-database -q; \
493 }}
494
495 %update_desktop_database_postun() {{ \
496 if [ $1 = 0 ]; then \
497         umask 022; \
498         /usr/bin/update-desktop-database -q; \
499 fi \
500 }}
501
502 #-----------------------------------------------------------------
503 # Update shared MIME info database
504 # requires: shared-mime-info
505 #
506 %update_mime_database() {{ \
507         umask 022; \
508         /usr/bin/update-mime-database %{_datadir}/mime; \
509 }}
510
511 #-----------------------------------------------------------------
512 # Update icon cache
513 # requires: gtk+
514 #
515 %update_icon_cache() {{ \
516         umask 022; \
517         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
518 }}
519
520 #-----------------------------------------------------------------
521 # Update scrollkeeper database
522 # requires: scrollkeeper
523 #
524 %scrollkeeper_update_post() \
525         /usr/bin/scrollkeeper-update -q; \
526         %{nil}
527
528 %scrollkeeper_update_postun() \
529 if [ $1 = 0 ]; then \
530         /usr/bin/scrollkeeper-update -q; \
531 fi \
532 %{nil}
533
534 #-----------------------------------------------------------------
535 # post %install sequence:
536 # - autodeps exceptions
537 # - compress all man and info pages,
538 # - strip all ELF executables and ELF shared objects if not %debug.
539 # - compress kernel modules if any
540
541 ###################################################################
542 # Requires/Provides automation
543 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
544 #
545 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
546 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
547 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
548 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
549 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
550 #%_noautocompressdoc    %{nil}
551 #
552 %_missing_doc_files_terminate_build     1%{nil}
553 %_unpackaged_files_terminate_build      %{nil}
554 # (X)emacs support
555 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
556 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
557 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
558
559 %__php_provides %{nil}
560 %__php_requires %{nil}
561 %__perl_provides %{nil}
562 %__perl_requires %{nil}
563 %__mono_provides %{nil}
564 %__mono_requires %{nil}
565
566 # Perl specific macro definitions.
567 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
568 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
569 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
570 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
571 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
572 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
573
574 # Ruby
575 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
576 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
577 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
578 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
579 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
580 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
581 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
582 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
583
584 %php_pear_dir           /usr/share/pear
585 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
586 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
587
588 # directory where php includes are installed on system.
589 %__php_includedir               /usr/include/php
590 # extract php/zend api versions
591 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
592 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
593 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
594 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
595 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
596 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
597 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
598
599 # helper macro
600 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
601
602 # macros for public use
603 # for php extensions (php-pecl)
604 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
605 %{__php_api_requires zend_module_api} \
606 %{__php_api_requires -v %php_major_version debug php_debug} \
607 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
608
609 # for zend extensions
610 %requires_zend_extension %{__php_api_requires zend_module_api} \
611 %{__php_api_requires zend_extension_api} \
612 %{__php_api_requires -v %php_major_version debug php_debug} \
613 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
614
615 # for php pdo modules (php-pecl-PDO_*)
616 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
617
618 # for using PHP post scripts. for PHP >= 5.0
619 %php_webserver_restart \
620 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
621 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
622 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
623         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
624         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
625                 %service -q php-fcgi restart \
626         fi \
627 fi \
628 %{nil}
629
630 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
631 %php4_webserver_restart \
632 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
633 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
634 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
635         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
636         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
637                 %service -q php-fcgi restart \
638         fi \
639 fi \
640 %{nil}
641
642 # Python specific macro definitions.
643 # python main version
644 %py_ver                 %(python -c "import sys; print sys.version[:3]")
645
646 # directories
647 %py_prefix              %(python -c "import sys; print sys.prefix")
648 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
649 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
650 %py_incdir              /usr/include/python%{py_ver}
651 %py_sitedir             %{py_libdir}/site-packages
652 %py_sitescriptdir %{py_scriptdir}/site-packages
653 %py_dyndir              %{py_libdir}/lib-dynload
654
655 # pure python modules compilation
656 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
657
658 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
659
660 # Software written in Python language require Python with main version
661 %pyrequires_eq() Requires:      %1
662
663 # Hardlink binary identical .pyc and .pyo files
664 # (idea by glen <at> pld-linux <dot> org)
665 %__spec_install_post_py_hardlink {\
666 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
667 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
668         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
669         if cmp -s "$a" "$b"; then \
670                 ln -f "$a" "$b"; \
671         fi; \
672 done \
673 }; __spec_install_post_py_hardlink } }
674
675 # remove python sources, so that check-files won't complain
676 # (idea by glen <at> pld-linux <dot> org)
677 %py_postclean() \
678 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
679  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
680 done \
681 %{nil}
682
683 # depmod macro
684 %depmod() { \
685 umask 022; \
686 if [ -e /boot/System.map-%1 ]; then \
687         /sbin/depmod -a -F /boot/System.map-%1 %1; \
688 else \
689         if [ -e /boot/System.map ]; then \
690                 /sbin/depmod -a -F /boot/System.map %1; \
691         else \
692                 /sbin/depmod -a %1; \
693         fi \
694 fi; \
695 }
696
697 # XMMS specific macros
698 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
699 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
700 %xmms_version                   %(xmms-config --version 2>/dev/null)
701 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
702 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
703 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
704 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
705 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
706 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
707 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
708
709 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
710
711 # user/group checking macros
712 #
713 # Usage:
714 #       %userremove myuser
715 #
716 %userremove     /usr/lib/rpm/user_group.sh user del
717 %groupremove    /usr/lib/rpm/user_group.sh group del
718 #
719 # Usage:
720 #       if %usertestrm myuser; then
721 #               /usr/sbin/userdel -r myuser
722 # Note:
723 #       use these macros only if you need to call userdel/groupdel with
724 #       a non-standard option or take an extra action; otherwise use the
725 #       %userremove/%groupremove macros
726 #
727 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
728 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
729 # user group membership management macros
730 #
731 # Usage:
732 #       %addusertogroup myuser agroup
733 #
734 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
735
736 # banner support (useful in {pre,post}{,un} and triggers)
737 #
738 # Usage:
739 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
740 # the banner text, the banner text
741 # the banner text, and following line
742 #EOF
743 # You can use any form of here-document, <<'EOF' <<-EOT will do.
744 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
745 #
746 # -a   - append to the banner
747 # -e   - send to stderr instead of stdout
748 # -n   - no show banner (overrides -t)
749 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
750 %banner(aent:)  \
751 RPM_SCRIPTVERBOSITY=5 \
752 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
753 if [ -x /usr/bin/banner.sh ]; then \
754         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
755 else \
756         CMD="cat%{-e: >&2}" \
757 fi \
758 eval $CMD %2%{?3: %3} \
759 %nil
760
761 # useradd/groupadd macros
762 # Author: Elan Ruusamäe <glen@pld-linux.org>
763 #
764 # Usage:
765 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
766 #   [-g initial_group] [-G group[,...]] login
767 #
768 #  -u uid. REQUIRED
769 #  -g gid/group. REQUIRED
770 #  -s defaults to /bin/false
771 #  -d defaults to /usr/share/empty
772 #  -c No default
773 #  -r is accepted but ignored (it's always set)
774 #  -k skeleton dir. defaults to /usr/share/empty
775 # rpm specific flags
776 #  -P package name. defaults to %{name}
777 #
778 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
779 %{!-u:%{error:useradd: Required argument -u missing}} \
780 %{!-g:%{error:useradd: Required argument -g missing}} \
781 %{!?1:%{error:useradd: Required parameter login missing}} \
782 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
783         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
784                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
785                 exit 1 \
786         fi \
787 else \
788         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
789         /usr/sbin/useradd \\\
790                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
791                 -u %{-u*} \\\
792                 -r \\\
793                 -d %{-d*}%{!-d:/usr/share/empty} \\\
794                 -s %{-s*}%{!-s:/bin/false} \\\
795                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
796                 -g %{-g*} \\\
797                 %{-M} \\\
798                 %{-G:-G %{-G*}} \\\
799                 %{expand:%{%{#}}} 1>&2 || exit $? \
800         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
801 fi;
802
803 # Usage:
804 #   %groupadd [-P package] [-g gid] group
805 #
806 # -g gid. REQUIRED
807 #
808 # Sample:
809 #   %groupadd -P %{name}-base -g %{gid} %{name}
810
811 %groupadd(g:P:rfo)      \
812 %{!-g:%{error:groupadd: Required argument -g missing}} \
813 %{!?1:%{error:groupadd: Required parameter group missing}} \
814 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
815         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
816                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
817                 exit 1 \
818         fi \
819 else \
820         echo "Adding group %{1} GID=%{-g*}." \
821         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
822         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
823 fi;
824
825 # apache_config_{install/uninstall} macros *DEPRECATED*
826 # Author: Elan Ruusamäe <glen@pld-linux.org>
827 #
828 # You should use webapp macros instead. these are here until single piece of
829 # them is gone from specs ;)
830 #
831 # The config is installed/removed inside trigger, this means that you can any
832 # time install apache1 or apache package and the configuration file is updated.
833 # if you don't need the config for various reason for specific apache, just
834 # remove the symlink from apache config directory. the trigger will not put the
835 # config again to that version of apache. In other words the config is linked
836 # to apache config directory on first install of PACKAGE or apache.
837 #
838 # should be called in trigger body:
839 #  %triggerin -- apache1 >= 1.3.33-2
840 #  %apache_config_install -v 1
841 #
842 # Add package's apache config to apache config.
843 #
844 # Usage:
845 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
846 #
847 #  -v REQUIRED: specify apache version. can be 1 or 2.
848 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
849 #  -n OPTIONAL: specify config "slot". defaults to 99
850 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
851 #
852 # Internal macros. don't use ;).
853 # expands apache config dir by apache version at build time.
854 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
855 # expands apache service name by apache version at build time.
856 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
857
858 %apache_config_install(fv:c:n:) \
859 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
860 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
861 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
862         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
863 fi\
864 # reload apache if the config symlink is there\
865 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
866         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
867         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
868                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
869         fi\
870 fi\
871 %{nil}
872
873 # Remove package's apache config from apache config.
874 #
875 # Usage:
876 #   %apache_config_uninstall -v {1|2} -n 99
877 #
878 #  -v REQUIRED: specify apache version. can be 1 or 2.
879 #  -n OPTIONAL: specify config "slot". defaults to 99
880 %apache_config_uninstall(v:n:) \
881 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
882 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
883 # remove link if either of the packages are gone \
884 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
885         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
886                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
887                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
888                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
889                 fi \
890         fi \
891 fi \
892 %{nil}
893
894 # webapp macros
895 # Author: Elan Ruusamäe <glen@pld-linux.org>
896 #
897 # The config is installed/removed inside trigger, this means that you can any
898 # time install apache1/apache/lighttpd package and the configuration file is
899 # updated. if you don't need the config for various reason for specific
900 # webserver, just remove the symlink from config directory using webapp
901 # program. the trigger will not recreate the symlink on upgrades. In other
902 # words the config is linked to webserver config directory on first install of
903 # PACKAGE or WEBSERVER.
904 #
905 # Add package's webserver config to webserver webapps dir.
906 # Usage:
907 #   %webapp_register WEBSERVER WEBAPP
908 #
909 %webapp_register() \
910 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
911 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
912         /usr/sbin/webapp register %1 %2\
913 fi\
914 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
915 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
916         %{expand:%service -q %%1 reload}\
917 fi\
918 %{nil}
919
920 # Remove package's config from webserver webapps dir.
921 # Usage:
922 #   %webapp_register [-f] WEBSERVER WEBAPP
923 %webapp_unregister(f) \
924 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
925 # remove link if either of the packages are gone \
926 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
927         /usr/sbin/webapp unregister %1 %2\
928         %{expand:%service -q %%1 reload}\
929 fi \
930 %{nil}
931
932 # see browser-plugins.spec / template-browser-plugin.spec
933 # Author: Elan Ruusamäe <glen@pld-linux.org>
934 %nsplugin_install(d:f) { \
935 # create link if it's first install of either of the packages \
936 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
937 ( \
938 %( \
939         for file in %{*}; do \
940                 echo echo Installing $file to %{-d*}; \
941                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
942         done ) \
943 ) | ( %banner -t 5 -e %{name}-in ); fi; \
944 }
945
946 %nsplugin_uninstall(d:) { \
947 # remove link if either of the packages are gone \
948 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
949 ( \
950 %( \
951         for file in %{*}; do \
952                 echo echo Removing $file from %{-d*}; \
953                 echo "rm -f %{-d*}/$file;"; \
954         done ) \
955 ) | ( %banner -t 5 -e %{name}-un ); fi; \
956 }
957
958 # service macro.
959 # Author: Elan Ruusamäe <glen@pld-linux.org>
960 #
961 # calls usual service restart on package %post, but skips the restart if
962 # administrator has disabled automatic service restarts in either global
963 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
964 #
965 # Usage:
966 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
967 #
968 #  -q be silent when service isn't started (for scriplets restaring other package's services)
969 #
970 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
971
972
973 # Java macros. based on jpackage macros.java
974 #
975 # Root directory where all Java VMs/SDK/JREs are installed.
976 %_jvmdir                %{_libdir}/jvm
977
978 # Root directory where all Java VMs/SDK/JREs expose their jars
979 %_jvmjardir             %{_libdir}/jvm-exports
980
981 # Root directory for all Java VM/SDK/JRE's private things.
982 %_jvmprivdir    %{_libdir}/jvm-private
983
984 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
985 %_jvmlibdir             %{_libdir}/jvm
986
987 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
988 %_jvmdatadir    %{_datadir}/jvm
989
990 # Root directory for all configurations parts of Java VM/SDK/JRE's
991 %_jvmsysconfdir %{_sysconfdir}/jvm
992
993 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
994 %_jvmcommonlibdir       %{_libdir}/jvm-common
995
996 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
997 %_jvmcommondatadir      %{_datadir}/jvm-common
998
999 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1000 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1001
1002 # Directory where arch-specific (JNI) version-independent jars are installed.
1003 %_jnidir                %{_libdir}/java
1004
1005
1006 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
1007
1008 %ant                    JAVA_HOME=%{java_home} ant
1009 %jar                    %{java_home}/bin/jar
1010 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
1011 %javac                  %{java_home}/bin/javac
1012 %javadoc                %{java_home}/bin/javadoc
1013
1014 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1015
1016 %jpackage_script() \
1017 install -d $RPM_BUILD_ROOT%{_bindir}\
1018 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1019 #!/bin/sh\
1020 #\
1021 # %{name} script\
1022 # JPackage Project <http://www.jpackage.org/>\
1023 \
1024 # Source functions library\
1025 . %{_javadir}-utils/java-functions\
1026 \
1027 # Source system prefs\
1028 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1029     . %{_sysconfdir}/java/%{name}.conf\
1030 fi\
1031 \
1032 # Source user prefs\
1033 if [ -f $HOME/.%{name}rc ]; then\
1034     . $HOME/.%{name}rc\
1035 fi\
1036 \
1037 # Configuration\
1038 MAIN_CLASS=%1\
1039 BASE_FLAGS=%2\
1040 BASE_OPTIONS=%3\
1041 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1042 \
1043 # Set parameters\
1044 set_jvm\
1045 set_classpath $BASE_JARS\
1046 set_flags $BASE_FLAGS\
1047 set_options $BASE_OPTIONS\
1048 \
1049 # Let's start\
1050 run "$@"\
1051 EOF
1052
1053 # PEAR install macros
1054 # Author: Elan Ruusamäe <glen@pld-linux.org>
1055 #
1056 # Usage:
1057 #       %%pear_package_setup [-a #] [-n FMT]
1058 #
1059 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1060 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1061 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1062 #
1063 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1064 # destination hierarchy. you should copy the tree to buildroot after
1065 # patching/reorganizing with %%pear_package_install.
1066 #
1067 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1068 # line endings.
1069 #
1070 # the pear install process output is recorded to install.log, you should put it
1071 # to %%doc for later debug or just for information.
1072 #
1073 # additionally additional-packages.txt is produced if it was detected that the
1074 # package has optional dependencies. the file format is suitable of displaying
1075 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1076 # automatically added for this file.
1077
1078
1079 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1080 %__pear_install_log \
1081 tee install.log \
1082 # make post message of optional packages \
1083 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1084 if [ -s optional-packages.txt ]; then \
1085         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1086 else \
1087         rm -f optional-packages.txt \
1088 fi \
1089 %{nil}
1090
1091 # command invoking pear cli
1092 %__pear /usr/bin/pear
1093
1094 # The main macro.
1095 # using this macro will append optional-packages.txt to the nocompressdoc list
1096 # as it's displayed to user after package install. and adding additional gzip
1097 # dep is just waste ;)
1098 %pear_package_setup(a:n:zD) \
1099 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1100 %define builddir %{_builddir}/%{srcdir} \
1101 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1102 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1103 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1104 %__pear \\\
1105         -c pearrc \\\
1106         -d doc_dir=/docs \\\
1107         -d php_dir=%{php_pear_dir} \\\
1108         -d bin_dir=%{_bindir} \\\
1109         -d data_dir=%{php_pear_dir}/data \\\
1110         -d test_dir=%{php_pear_dir}/tests \\\
1111         install \\\
1112         --packagingroot=%{builddir} \\\
1113         --offline \\\
1114         --nodeps \\\
1115         %{-f:--force} \\\
1116         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1117 %{-z:cd ..} \
1118 cat %{-z:$_N/}.install.log | %__pear_install_log \
1119 \
1120 # undos sources \
1121 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1122 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1123 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1124 %{nil}
1125
1126 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1127 # Author: Elan Ruusamäe <glen@pld-linux.org>
1128 %pear_package_install() \
1129 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1130 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1131 # help the developer out a little: \
1132 if [ -f _noautoreq ]; then \
1133         echo "AutoReqdep detected:" \
1134         echo "_noautoreq $(cat _noautoreq)" \
1135 fi \
1136 %{nil}
1137
1138
1139 # Register OpenLDAP schema.
1140 # Author: Elan Ruusamäe <glen@pld-linux.org>
1141 #
1142 # Usage:
1143 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1144 #
1145 #  -d specify dependant schemas, separated by comma
1146 #
1147 %openldap_schema_register(d:) \
1148 for schema in %*; do \
1149         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1150                 %{__sed} -i -e " \
1151                         /^include.*local.schema/{ \
1152                                 iinclude\\t     $schema\
1153                         } \
1154                 " /etc/openldap/slapd.conf \
1155         fi \
1156 done \
1157 # enable dependant schemas \
1158 if [ "%{-d*}" ]; then \
1159         %{__sed} -i -e ' \
1160         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1161                 s/^#// \
1162         }' /etc/openldap/slapd.conf \
1163 fi \
1164 %{nil}
1165
1166 # Unregister OpenLDAP schema.
1167 # Author: Elan Ruusamäe <glen@pld-linux.org>
1168 #
1169 # Usage:
1170 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1171 #
1172 %openldap_schema_unregister() \
1173 for schema in %*; do \
1174         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1175                 %{__sed} -i -e " \
1176                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1177                 # for symmetry it would be nice if we disable enabled schemas in post, \
1178                 # but we really can not do that, it would break something else. \
1179                 " /etc/openldap/slapd.conf \
1180         fi \
1181 done \
1182 %{nil}
1183
1184 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1185
1186
1187 # Build modules for kernels 2.6
1188 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1189 #
1190 # Usage:
1191 #       %build_kernel_modules -m <modules> -C <directory>
1192 #
1193 #  remember that proper Makefile is still required
1194 # Options:
1195 #  -m <modules> (required) -- comma-separated list of modules to save,
1196 #               without .ko extension, may be placed in subdirectory
1197 #  -C <directory> -- change to <directory> before doing anything
1198 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1199 #  -c -- do not execute make clean
1200 #  <additional arguments> -- all additional arguments will be passed to
1201 #               make modules
1202 #
1203 # Additional patching supported via here document. Try:
1204 #       %build_kernel_modules -m module <<'EOF'
1205 #       your patch script here
1206 #       EOF
1207 # Don't use it unless patching depends on config options.
1208
1209 # Developer note: don't touch it unless you know how to handle '\'.
1210 # - \ in script expands to nothing
1211 # - \\\ in script expands to \
1212 # - \\\ inside definition expands to nothing
1213 # - \\\\\\\ inside definition expands to \
1214 # - in last line \ has to touch arguments so arguments passing
1215 #   in new lines (using \) will be supported
1216
1217 %build_kernel_modules(p:P:m:C:c)                                                                        \
1218 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1219                                                                                                                                         \
1220 %define Opts                                                                                                            \\\\\\\
1221 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1222         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1223         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1224         %else                                                                                                                   \\\
1225         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1226         %endif                                                                                                                  \\\
1227 %else                                                                                                                           \\\
1228         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1229 %endif                                                                                                                          \
1230 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1231                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1232                                                                                                                                         \
1233 %{?-C:cd %{-C*}}                                                                                                        \
1234 compile() {                                                                                                                     \
1235         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1236         set -e -x                                                                                                               \
1237                                                                                                                                         \
1238 for cfg in %{?with_dist_kernel:dist}%{!?with_dist_kernel:nondist}; do \
1239         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1240                                                                                                                                         \
1241         rm -rf o                                                                                                                \
1242         install -d o/include/linux                                                                              \
1243         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1244         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1245         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1246 %ifarch ppc ppc64                                                                                                       \
1247         install -d o/include/asm                                                                                \
1248         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1249         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm   \
1250 %else                                                                                                                           \
1251         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1252 %endif                                                                                                                          \
1253                                                                                                                                         \
1254         set +x                                                                                                                  \
1255         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1256         set -x                                                                                                                  \
1257                                                                                                                                         \
1258         %if %{with dist_kernel}                                                                                 \
1259                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1260                         %{-p*} %{-P*}                                                                                   \\\
1261                         %{MakeOpts}                                                                                             \
1262         %else                                                                                                                   \
1263                 install -d o/include/config                                                                     \
1264                 touch o/include/config/MARKER                                                           \
1265                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1266         %endif                                                                                                                  \
1267                                                                                                                                         \
1268         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1269                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1270                 M=$PWD %{MakeOpts}}                                                                                     \
1271         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1272                 ${1+"$@"}                                                                                                       \\\
1273                 M=$PWD %{MakeOpts}                                                                                      \
1274                                                                                                                                         \
1275         for MODULE in {%{-m*},}; do                                                                             \
1276                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1277         done                                                                                                                    \
1278 done                                                                                                                            \
1279 %{?-C:cd -}                                                                                                                     \
1280 }                                                                                                                                       \
1281 compile %{*}\
1282 %{nil}
1283
1284
1285 # Install kernel modules built by %build_kernel_modules
1286 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1287 #
1288 # Usage:
1289 #       %install_kernel_modules -m <modules> -d <directory>
1290 #
1291 # Options:
1292 #  -m <modules> (required) -- comma-separated list of modules to install,
1293 #               without .ko extension, may be placed in subdirectory
1294 #  -d <directory> (required) -- in what subdirectory modules should be
1295 #               installed (eg. misc, kernel/drivers/net)
1296 #  -s <suffix> -- suffix to use when installing modules, useful when module
1297 #               with same name exists in kernel already
1298 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1299 #               for definig aliases, only useful with -s
1300
1301 %install_kernel_modules(m:d:s:n:)                                                                       \
1302 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1303 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1304 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1305                                                                                                                                         \
1306 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1307 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1308                                                                                                                                         \
1309 install -d %{KernelD}/%{-d*}                                                                    \
1310 %{?-s:install -d %{ModprobeD}}                                                          \
1311                                                                                                                                         \
1312 for MODULE in {%{-m*},}; do                                                                                     \
1313         [ -n "${MODULE}" ] || continue                                                                  \
1314         MNAME=${MODULE##*/}                                                                                             \
1315         %if %{without dist_kernel}                                                                              \
1316                 install ${MODULE}-nondist.ko                                                            \\\
1317                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1318                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1319                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1320         %else                                                                                                                   \
1321                 install ${MODULE}-dist.ko                                                                               \\\
1322                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1323                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1324                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1325         %endif                                                                                                                  \
1326 done                                                                                                                            \
1327 %{nil}
1328
1329 # patchset macros
1330 # Author: Elan Ruusamäe <glen@pld-linux.org>
1331 #
1332 # Usage:
1333 #   %patchset_source -f <seq(1) format> <start> [<end>]
1334 #   %patchset_patch <start> [<end>]
1335 #
1336 # If <end> is omited, it is assumed to be <start>.
1337 #
1338 # For example in preamble:
1339 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1340 # and in %prep:
1341 #  %patchset_patch 33 44
1342
1343 # generate SourceX urls from range START STOP
1344 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1345 # The sources start from 10000
1346 %patchset_source(f:b:) %(
1347         base=%{-b*}%{!-b*:10000};
1348         start=$(expr $base + %1);
1349         end=$(expr $base + %{?2}%{!?2:%{1}});
1350         # we need to call seq twice as it doesn't allow two formats
1351         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1352         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1353         paste %{tmpdir}/__ps{1,2};
1354         rm -f %{tmpdir}/__ps{1,2};
1355 ) \
1356 %{nil}
1357
1358 # apply sources from %patchset_source
1359 # -p specify -pX for %patch line
1360 # -b base offset: defaults to 10000
1361 %patchset_patch(f:p:b:) %(
1362         base=%{-b*}%{!-b*:10000};
1363         start=$(expr $base + %1);
1364         end=$(expr $base + %{?2}%{!?2:%{1}});
1365         echo ": patchset_patch %1%{?2: to %2}";
1366         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1367 ) \
1368 %{nil}
1369
1370 # browser plugins v2
1371 # Author: Elan Ruusamäe <glen@pld-linux.org>
1372 #
1373 # Usage:
1374 #       %browser_plugins_add_browser <name> -p <plugindir>
1375 #
1376 #  <name> (required) -- name of the browser. usually %{name}.
1377 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1378 #  -b -- default blacklists
1379 #  -a <arch> override arch
1380 #
1381 # Example:
1382 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1383
1384 %_browserpluginsconfdir         /etc/browser-plugins
1385 %_browserpluginsdir                     %{_libdir}/browser-plugins
1386 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1387
1388 %browser_plugins_add_browser(p:b:a:) \
1389         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1390         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1391         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1392         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1393         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1394         %{-b:cat >> $blacklist_file %{-b*}} \
1395 %{nil}
1396
1397 # vim:ts=4 sw=4 noet syn=spec
This page took 0.306783 seconds and 3 git commands to generate.